//
// DO NOT EDIT THIS FILE.Generated using AndroidAnnotations 3.3.2.
//  You can create a larger work that contains this file and distribute that work under terms of your choice.
//


package org.transdroid.core.gui;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Build.VERSION;
import android.os.Build.VERSION_CODES;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.support.v4.app.ActivityCompat;
import android.support.v7.widget.Toolbar;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup.LayoutParams;
import org.androidannotations.api.BackgroundExecutor;
import org.androidannotations.api.SdkVersionHelper;
import org.androidannotations.api.builder.ActivityIntentBuilder;
import org.androidannotations.api.view.HasViews;
import org.androidannotations.api.view.OnViewChangedListener;
import org.androidannotations.api.view.OnViewChangedNotifier;
import org.transdroid.R.layout;
import org.transdroid.core.app.settings.ApplicationSettings_;
import org.transdroid.core.gui.log.Log_;
import org.transdroid.core.gui.navigation.NavigationHelper_;
import org.transdroid.core.service.ConnectivityHelper_;
import org.transdroid.daemon.Priority;
import org.transdroid.daemon.Torrent;
import org.transdroid.daemon.TorrentDetails;
import org.transdroid.daemon.TorrentFile;
import org.transdroid.daemon.task.DaemonTaskFailureResult;
import org.transdroid.daemon.task.DaemonTaskSuccessResult;

public final class DetailsActivity_
    extends DetailsActivity
    implements HasViews, OnViewChangedListener
{

    private final OnViewChangedNotifier onViewChangedNotifier_ = new OnViewChangedNotifier();
    public final static String CURRENT_LABELS_EXTRA = "currentLabels";
    public final static String TORRENT_EXTRA = "torrent";
    private Handler handler_ = new Handler(Looper.getMainLooper());

    @java.lang.Override
    public void onCreate(Bundle savedInstanceState) {
        OnViewChangedNotifier previousNotifier = OnViewChangedNotifier.replaceNotifier(onViewChangedNotifier_);
        init_(savedInstanceState);
        super.onCreate(savedInstanceState);
        OnViewChangedNotifier.replaceNotifier(previousNotifier);
        setContentView(layout.activity_details);
    }

    private void init_(Bundle savedInstanceState) {
        OnViewChangedNotifier.registerOnViewChangedListener(this);
        log = Log_.getInstance_(this);
        connectivityHelper = ConnectivityHelper_.getInstance_(this);
        navigationHelper = NavigationHelper_.getInstance_(this);
        applicationSettings = ApplicationSettings_.getInstance_(this);
        injectExtras_();
        restoreSavedInstanceState_(savedInstanceState);
    }

    @java.lang.Override
    public void setContentView(int layoutResID) {
        super.setContentView(layoutResID);
        onViewChangedNotifier_.notifyViewChanged(this);
    }

    @java.lang.Override
    public void setContentView(View view, LayoutParams params) {
        super.setContentView(view, params);
        onViewChangedNotifier_.notifyViewChanged(this);
    }

    @java.lang.Override
    public void setContentView(View view) {
        super.setContentView(view);
        onViewChangedNotifier_.notifyViewChanged(this);
    }

    public static DetailsActivity_.IntentBuilder_ intent(Context context) {
        return new DetailsActivity_.IntentBuilder_(context);
    }

    public static DetailsActivity_.IntentBuilder_ intent(android.app.Fragment fragment) {
        return new DetailsActivity_.IntentBuilder_(fragment);
    }

    public static DetailsActivity_.IntentBuilder_ intent(android.support.v4.app.Fragment supportFragment) {
        return new DetailsActivity_.IntentBuilder_(supportFragment);
    }

    @java.lang.Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (((SdkVersionHelper.getSdkInt()< 5)&&(keyCode == KeyEvent.KEYCODE_BACK))&&(event.getRepeatCount() == 0)) {
            onBackPressed();
        }
        return super.onKeyDown(keyCode, event);
    }

    @java.lang.Override
    public void onViewChanged(HasViews hasViews) {
        selectionToolbar = ((Toolbar) hasViews.findViewById(org.transdroid.R.id.selection_toolbar));
        fragmentDetails = ((DetailsFragment) findNativeFragmentById(org.transdroid.R.id.torrentdetails_fragment));
        init();
    }

    private android.app.Fragment findNativeFragmentById(int id) {
        return getFragmentManager().findFragmentById(id);
    }

    @java.lang.Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater menuInflater = getMenuInflater();
        menuInflater.inflate(org.transdroid.R.menu.activity_details, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @java.lang.Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int itemId_ = item.getItemId();
        if (itemId_ == android.R.id.home) {
            navigateUp();
            return true;
        }
        if (itemId_ == org.transdroid.R.id.action_refresh) {
            refreshScreen();
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    private void injectExtras_() {
        Bundle extras_ = getIntent().getExtras();
        if (extras_!= null) {
            if (extras_.containsKey(CURRENT_LABELS_EXTRA)) {
                currentLabels = extras_.getParcelableArrayList(CURRENT_LABELS_EXTRA);
            }
            if (extras_.containsKey(TORRENT_EXTRA)) {
                torrent = extras_.getParcelable(TORRENT_EXTRA);
            }
        }
    }

    @java.lang.Override
    public void setIntent(Intent newIntent) {
        super.setIntent(newIntent);
        injectExtras_();
    }

    @java.lang.Override
    public void onSaveInstanceState(Bundle bundle_) {
        super.onSaveInstanceState(bundle_);
        bundle_.putParcelable("torrent", torrent);
        bundle_.putParcelableArrayList("currentLabels", currentLabels);
    }

    private void restoreSavedInstanceState_(Bundle savedInstanceState) {
        if (savedInstanceState == null) {
            return ;
        }
        torrent = savedInstanceState.getParcelable("torrent");
        currentLabels = savedInstanceState.getParcelableArrayList("currentLabels");
    }

    @java.lang.Override
    public void onTaskSucceeded(final DaemonTaskSuccessResult result, final String successMessage) {
        handler_.post(new Runnable() {


            @java.lang.Override
            public void run() {
                DetailsActivity_.super.onTaskSucceeded(result, successMessage);
            }

        }
        );
    }

    @java.lang.Override
    public void onCommunicationError(final DaemonTaskFailureResult result, final boolean isCritical) {
        handler_.post(new Runnable() {


            @java.lang.Override
            public void run() {
                DetailsActivity_.super.onCommunicationError(result, isCritical);
            }

        }
        );
    }

    @java.lang.Override
    public void closeActivity(final String closeText) {
        handler_.post(new Runnable() {


            @java.lang.Override
            public void run() {
                DetailsActivity_.super.closeActivity(closeText);
            }

        }
        );
    }

    @java.lang.Override
    public void onTorrentsRetrieved(final List<Torrent> torrents, final List<org.transdroid.daemon.Label> labels) {
        handler_.post(new Runnable() {


            @java.lang.Override
            public void run() {
                DetailsActivity_.super.onTorrentsRetrieved(torrents, labels);
            }

        }
        );
    }

    @java.lang.Override
    public void onTorrentFilesRetrieved(final Torrent torrent, final List<TorrentFile> torrentFiles) {
        handler_.post(new Runnable() {


            @java.lang.Override
            public void run() {
                DetailsActivity_.super.onTorrentFilesRetrieved(torrent, torrentFiles);
            }

        }
        );
    }

    @java.lang.Override
    public void onTorrentDetailsRetrieved(final Torrent torrent, final TorrentDetails torrentDetails) {
        handler_.post(new Runnable() {


            @java.lang.Override
            public void run() {
                DetailsActivity_.super.onTorrentDetailsRetrieved(torrent, torrentDetails);
            }

        }
        );
    }

    @java.lang.Override
    public void startTorrent(final Torrent torrent, final boolean forced) {
        BackgroundExecutor.execute(new BackgroundExecutor.Task("", 0, "") {


            @java.lang.Override
            public void execute() {
                try {
                    DetailsActivity_.super.startTorrent(torrent, forced);
                } catch (Throwable e) {
                    Thread.getDefaultUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), e);
                }
            }

        }
        );
    }

    @java.lang.Override
    public void pauseTorrent(final Torrent torrent) {
        BackgroundExecutor.execute(new BackgroundExecutor.Task("", 0, "") {


            @java.lang.Override
            public void execute() {
                try {
                    DetailsActivity_.super.pauseTorrent(torrent);
                } catch (Throwable e) {
                    Thread.getDefaultUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), e);
                }
            }

        }
        );
    }

    @java.lang.Override
    public void updatePriority(final Torrent torrent, final List<TorrentFile> files, final Priority priority) {
        BackgroundExecutor.execute(new BackgroundExecutor.Task("", 0, "") {


            @java.lang.Override
            public void execute() {
                try {
                    DetailsActivity_.super.updatePriority(torrent, files, priority);
                } catch (Throwable e) {
                    Thread.getDefaultUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), e);
                }
            }

        }
        );
    }

    @java.lang.Override
    public void refreshTorrentDetails(final Torrent torrent) {
        BackgroundExecutor.execute(new BackgroundExecutor.Task("", 0, "") {


            @java.lang.Override
            public void execute() {
                try {
                    DetailsActivity_.super.refreshTorrentDetails(torrent);
                } catch (Throwable e) {
                    Thread.getDefaultUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), e);
                }
            }

        }
        );
    }

    @java.lang.Override
    public void updateLabel(final Torrent torrent, final String newLabel) {
        BackgroundExecutor.execute(new BackgroundExecutor.Task("", 0, "") {


            @java.lang.Override
            public void execute() {
                try {
                    DetailsActivity_.super.updateLabel(torrent, newLabel);
                } catch (Throwable e) {
                    Thread.getDefaultUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), e);
                }
            }

        }
        );
    }

    @java.lang.Override
    public void updateTrackers(final Torrent torrent, final List<String> newTrackers) {
        BackgroundExecutor.execute(new BackgroundExecutor.Task("", 0, "") {


            @java.lang.Override
            public void execute() {
                try {
                    DetailsActivity_.super.updateTrackers(torrent, newTrackers);
                } catch (Throwable e) {
                    Thread.getDefaultUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), e);
                }
            }

        }
        );
    }

    @java.lang.Override
    public void refreshTorrentFiles(final Torrent torrent) {
        BackgroundExecutor.execute(new BackgroundExecutor.Task("", 0, "") {


            @java.lang.Override
            public void execute() {
                try {
                    DetailsActivity_.super.refreshTorrentFiles(torrent);
                } catch (Throwable e) {
                    Thread.getDefaultUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), e);
                }
            }

        }
        );
    }

    @java.lang.Override
    public void resumeTorrent(final Torrent torrent) {
        BackgroundExecutor.execute(new BackgroundExecutor.Task("", 0, "") {


            @java.lang.Override
            public void execute() {
                try {
                    DetailsActivity_.super.resumeTorrent(torrent);
                } catch (Throwable e) {
                    Thread.getDefaultUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), e);
                }
            }

        }
        );
    }

    @java.lang.Override
    public void removeTorrent(final Torrent torrent, final boolean withData) {
        BackgroundExecutor.execute(new BackgroundExecutor.Task("", 0, "") {


            @java.lang.Override
            public void execute() {
                try {
                    DetailsActivity_.super.removeTorrent(torrent, withData);
                } catch (Throwable e) {
                    Thread.getDefaultUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), e);
                }
            }

        }
        );
    }

    @java.lang.Override
    public void forceRecheckTorrent(final Torrent torrent) {
        BackgroundExecutor.execute(new BackgroundExecutor.Task("", 0, "") {


            @java.lang.Override
            public void execute() {
                try {
                    DetailsActivity_.super.forceRecheckTorrent(torrent);
                } catch (Throwable e) {
                    Thread.getDefaultUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), e);
                }
            }

        }
        );
    }

    @java.lang.Override
    public void updateLocation(final Torrent torrent, final String newLocation) {
        BackgroundExecutor.execute(new BackgroundExecutor.Task("", 0, "") {


            @java.lang.Override
            public void execute() {
                try {
                    DetailsActivity_.super.updateLocation(torrent, newLocation);
                } catch (Throwable e) {
                    Thread.getDefaultUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), e);
                }
            }

        }
        );
    }

    @java.lang.Override
    public void refreshTorrent() {
        BackgroundExecutor.execute(new BackgroundExecutor.Task("", 0, "") {


            @java.lang.Override
            public void execute() {
                try {
                    DetailsActivity_.super.refreshTorrent();
                } catch (Throwable e) {
                    Thread.getDefaultUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), e);
                }
            }

        }
        );
    }

    @java.lang.Override
    public void stopTorrent(final Torrent torrent) {
        BackgroundExecutor.execute(new BackgroundExecutor.Task("", 0, "") {


            @java.lang.Override
            public void execute() {
                try {
                    DetailsActivity_.super.stopTorrent(torrent);
                } catch (Throwable e) {
                    Thread.getDefaultUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), e);
                }
            }

        }
        );
    }

    public static class IntentBuilder_
        extends ActivityIntentBuilder<DetailsActivity_.IntentBuilder_>
    {

        private android.app.Fragment fragment_;
        private android.support.v4.app.Fragment fragmentSupport_;

        public IntentBuilder_(Context context) {
            super(context, DetailsActivity_.class);
        }

        public IntentBuilder_(android.app.Fragment fragment) {
            super(fragment.getActivity(), DetailsActivity_.class);
            fragment_ = fragment;
        }

        public IntentBuilder_(android.support.v4.app.Fragment fragment) {
            super(fragment.getActivity(), DetailsActivity_.class);
            fragmentSupport_ = fragment;
        }

        @java.lang.Override
        public void startForResult(int requestCode) {
            if (fragmentSupport_!= null) {
                fragmentSupport_.startActivityForResult(intent, requestCode);
            } else {
                if (fragment_!= null) {
                    if (VERSION.SDK_INT >= VERSION_CODES.JELLY_BEAN) {
                        fragment_.startActivityForResult(intent, requestCode, lastOptions);
                    } else {
                        fragment_.startActivityForResult(intent, requestCode);
                    }
                } else {
                    if (context instanceof Activity) {
                        Activity activity = ((Activity) context);
                        ActivityCompat.startActivityForResult(activity, intent, requestCode, lastOptions);
                    } else {
                        if (VERSION.SDK_INT >= VERSION_CODES.JELLY_BEAN) {
                            context.startActivity(intent, lastOptions);
                        } else {
                            context.startActivity(intent);
                        }
                    }
                }
            }
        }

        public DetailsActivity_.IntentBuilder_ currentLabels(ArrayList<org.transdroid.core.gui.navigation.Label> currentLabels) {
            return super.extra(CURRENT_LABELS_EXTRA, ((Serializable) currentLabels));
        }

        public DetailsActivity_.IntentBuilder_ torrent(Torrent torrent) {
            return super.extra(TORRENT_EXTRA, torrent);
        }

    }

}
